/**
 * Copyright (c) 2004 Logos GmbH Rostock (www.logos-ib.de).
 * All rights reserved.
 *
 * THIS SOFTWARE IS  PROVIDED  "AS IS"  AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF  MERCHANTABILITY  AND  FITNESS  FOR  A PARTICULAR  PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL  LOGOS GMBH  OR ITS CONTRIBUTORS BE
 * LIABLE FOR ANY  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 * OR CONSEQUENTIAL DAMAGES  (INCL., BUT NOT LIMITED TO, PROCUREMENT
 * OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR  PROFITS;
 * OR BUSINESS INTERRUPTION)  HOWEVER  CAUSED  AND  ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,  OR TORT (INCL.
 * NEGLIGENCE OR OTHERWISE)  ARISING  IN  ANY  WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package de.inovat.kex.bast.common.datawrapper;


/*
 * Revision 1.1  2007/07/04 11:43:27  Trier
 * Neuordnung
 */


import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.config.*;


/**
 * Klasse zum Cachen der IntegerValueRange f&uuml;r Attribute.
 * 
 * @author LOGOS GmbH Rostock (www.logos-ib.de)
 * @author Ralf Trier
 * @version $Id: ValueRangeHashtable.java 442 2008-11-10 06:59:32Z Schawaller $
 */
public class ValueRangeHashtable extends java.lang.Object {

  private static DataModel __DataModel;
  private static java.util.Hashtable<String, IntegerValueRange> __Hashtable;

  private static ValueRangeHashtable __Instance;

  private ValueRangeHashtable(Data data) {
    if (data.isPlain()) {
      __DataModel = data.getAttributeType().getDataModel();
      __Hashtable = new java.util.Hashtable<String, IntegerValueRange>();
    }
    else {
      throw new java.lang.IllegalArgumentException("data.isPlain must be true");
    }
  }

  public static ValueRangeHashtable getInstance(Data data) throws IllegalArgumentException {
    if (__Instance == null) {
      __Instance = new ValueRangeHashtable(data);
    }
    return __Instance;
  }

  public IntegerValueRange get(String attributePid) throws IllegalArgumentException {
    IntegerValueRange oValueRange;
    Object o = __Hashtable.get(attributePid);
    if (o == null) {
      try {
        IntegerAttributeType oIntAttrType = (IntegerAttributeType) __DataModel.getAttributeType(attributePid);
        if (oIntAttrType == null) {
          throw new IllegalArgumentException("AttributeType " + attributePid + " not defined in DataModel");
        }
        else {
          oValueRange = oIntAttrType.getRange();
          __Hashtable.put(attributePid, oValueRange);
        }
      }
      catch (ClassCastException e) {
        throw new IllegalArgumentException("attributePID mus PID of an IntegerAttributeType");
      }
    }
    else {
      oValueRange = (IntegerValueRange)o;
    }
    return oValueRange;
  }

}
