/*
 * Copyright (c) 2010 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kniss
 *
 * This file is part of de.inovat.kex.bast.importer.Stundendatensatz8Plus1
 *
 * de.inovat.kex.bast.importer.Stundendatensatz8Plus1 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * de.inovat.kex.bast.importer.Stundendatensatz8Plus1 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * <p>
 * You should have received a copy of the GNU General Public License
 * along with de.inovat.kex.bast.importer.Stundendatensatz8Plus1; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Contact Information:
 * inovat, Dipl.-Ing. H. C. Kniss
 * Koelner Strasse 30
 * D-50859 Köln
 * +49 (0)2234 4301 800
 * info@invat.de
 * www.inovat.de
 */



package de.inovat.kex.bast.importer;

//~ JDK IMPORTE ===============================================================

import java.util.HashMap;
import java.util.Map;

//~ KLASSEN ===================================================================

/**
 * Die Klasse reprästentiert EINEN Stundendatensätze der Fahrzeugklassifizierung 8+1 für
 * genau einen Fahrstreifen.
 * Bei den Stundendatensätzen sind folgende Daten zu repräsentieren:
 * Anfangszeitpunkt (Datum mit dem Format yymmdd hhmm)
 * Endzeitpunkt (s.o.)
 * _mapFZArtVerkehrsMege  (Map mit Schlüssel Fahrzeugart, Wert VerkehrsMenge _mapFZArtVerkehrsMege, wobei
 * die Werte direkt den DaV Werten entsprechen, d.h. z.B. (qKrad, 0) entspricht dann einem
 * Eintrag in den Stundensätzen Mot.
 */
public class Stundendatensatz {

    /** Map mit Schlüssel Fahrzeugart, Wert VerkehrsMenge. */
    private Map<String, String> _mapFZArtVerkehrsMenge = new HashMap<String, String>();

    /**
     * Map mit Schlüssel Gruppe Wert Map mit Geschwindigkeitsklasse als Schlüssel wert entspricht der Anzahl der FZ in der
     * Geschwindigkeitsklasse.
     */
    private Map<String, HashMap<Integer, String>> _gKlasseVerkehrsMengeGKlasse = new HashMap<String, HashMap<Integer, String>>();

    /** Zeitwert, für den der Stundendatensatz gültig ist. */
    private long _datumZeit;

    //~ GET METHODEN ==========================================================

    public long getDatumZeit() {
        return _datumZeit;
    }

    public Map<String, HashMap<Integer, String>> getGKlasseVerkehrsMengeGKlasse() {
        return _gKlasseVerkehrsMengeGKlasse;
    }

    public Map<String, String> getMapFZArtVerkehrsMenge() {
        return _mapFZArtVerkehrsMenge;
    }

    //~ SET METHODEN ==========================================================

    public void setDatumZeit(long datumZeit) {
        _datumZeit = datumZeit;
    }

    public void setGKlasseVerkehrsMengeGKlasse(Map<String, HashMap<Integer, String>> _gKlasseVerkehrsMengeGKlasse) {
        this._gKlasseVerkehrsMengeGKlasse = _gKlasseVerkehrsMengeGKlasse;
    }

    public void setMapFZArtVerkehrsMenge(Map<String, String> mapFZArtVerkehrsMenge) {
        _mapFZArtVerkehrsMenge = mapFZArtVerkehrsMenge;
    }
}


//~Formatiert mit 'inovat Kodierkonvention' am 30.07.12
